#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include "uart.h"
#include "pga2310.h"

SIGNAL(SIG_INT0) { /* nix machen */ }

int main( void )
{
	unsigned char mode, command, rcvdByte, column; 
	unsigned char left_vol, right_vol , tmp_mute ;
  
  Bios_InitUART(); // 38400 bps at 8 MHz

  
  Bios_PutString("\n\r PGA 2310 Volume Control Rev. 0.14\n\r");   // an RS232
  Bios_PutString("\n\r "__DATE__" "__TIME__" \n\r\n\r");   // an RS232
  
  pga_init();

//-----------------------------------------------------------------------------------------------
//  Init PGA 2310 MUTE off - der Wert 192 entspricht dem Wert von 0 dB
//-----------------------------------------------------------------------------------------------
  left_vol=192 ;                             // linker Kanal 0 db laden  
  right_vol=192 ;                            // linker Kanal 0 db laden 
  pga_set_volume(left_vol, right_vol);       // Senden der Werte an den PGA 2310
  pga_set_mute(0);                           // Mute Funktion aus                       
//-----------------------------------------------------------------------------------------------
  sei();             // interrupt Freigabe 

	mode = 1;
	command = 0;
	column = 10;
  tmp_mute = 0;

	
while (1){
    if (UARTdataReceived())
      {
			rcvdByte = receiveByte();
			switch (rcvdByte)
        {
        case 0xFE :
        mode = 1; break;
//-----------------------------------------------------------------------------------------------
        case '+' :                                  // Volume +
          if (mode)
            {
            right_vol=right_vol+2 ;                 // + 1 dB Schritt
            left_vol=left_vol+2 ;                   // + 1 dB Schritt
            pga_set_volume(left_vol, right_vol);    // sende Werte an PGA2310
            PutChar_db (right_vol);                 // Ausgabe via Seriell in dB  
            }
            else{mode = 0;}
            break;
//-----------------------------------------------------------------------------------------------
        case '-' :                                  // Volume -
          if (mode)
          {
				  right_vol=right_vol-2 ;                   // - 1 dB Schritt 
          left_vol=left_vol-2 ;                     // - 1 dB Schritt
          pga_set_volume(left_vol, right_vol);      // sende Werte an PGA2310
          PutChar_db (right_vol);                   // Ausgabe via Seriell in dB
          }
        else{mode = 0;}
        break;
//-----------------------------------------------------------------------------------------------
      case 'm' :                                    // Mute EIN
        if (mode) 
          { 
          tmp_mute = tmp_mute ^ (0xff);             // Toggel Mute Byte on/off
          pga_set_mute(tmp_mute);
         }
				else{mode = 0;}
        break;
//-----------------------------------------------------------------------------------------------
      case 'd' :                                    // default Werte setzen
        if (mode) 
          {
          left_vol=192 ;
          right_vol=192 ;
          pga_set_volume(left_vol, right_vol); 
          PutChar_db (right_vol);                   // Ausgabe via Seriell in dB
          }
				else{mode = 0;}
        break;
//-----------------------------------------------------------------------------------------------
     default : {  }
//-----------------------------------------------------------------------------------------------
			}
	  }		
  }
}

