#include "pga2310.h"

static inline void spi_write(uint8_t byte)              // Senden von 8 Bit via soft SPI 
{
	uint8_t i;
	for (i=0; i < 8; i++)
	{
      PORTB |= (1<<PGA_USCK_PIN);         // clock PIN auf 1
      if (0x80 & byte) {	                   // MSB is set
        PORTB |=(1<<PGA_DO_PIN);            // Data Pin auf 1 
      } else {
        PORTB &= ~(1<<PGA_DO_PIN);          // Data Pin auf 0
      }
		byte <<= 1;                            // Bit nach links shiften     
    PORTB &= ~(1<<PGA_USCK_PIN);        // clock PIN auf 0
	}
    PORTB |=(1<<PGA_DO_PIN);            // Data auf high
}

void pga_init(void)
{
  DDRB = 0x1E;
  PORTB |= (1 << PGA_CS_PIN);         // set /CS Pin high
  PORTB |= (1 <<PGA_USCK_PIN);        // Clock auf high 
  PORTB |= (1 <<PGA_DO_PIN);          // Data auf high
}


void pga_set_mute(uint8_t muted)                      // setze Mute wenn Bit gesetzt
	{
		if (muted)
			PORTB &= ~(1 << PGA_MT_PIN);                   // Bit MUTE lschen ( Mute low aktive )  
		else
			PORTB |= (1 << PGA_MT_PIN);                    // Bit MUTE setzen
	//	pga_status.muted = muted;
	}


void pga_set_volume(uint8_t left, uint8_t right)
{
  PORTB &= ~(1 << PGA_CS_PIN);                        // aktiviere /CS Pin
//  _delay_ms(2);  
  spi_write(right);		                                 // schreibe Volume right Chanel 
	spi_write(left);		                                 // schreibe Volume left Chanel 
//  _delay_ms(2);  
	PORTB |= (1 << PGA_CS_PIN);                         // deaktiviere /CS Pin        
}

void PutChar_db(uint8_t vol_db)  // Umrechnung und Ausgabe in dB
{
  if (vol_db == 192) 
      {Bios_PutString("  0");};   // Wert 192 immer als 0 dB ausgeben                
  if (vol_db > 192)               // Wert grsser 192 = 0 dB und mehr 
     {
      Bios_PutString("+ ");
      Bios_PutChar_P((vol_db-192) / 2);
      };          
  if (vol_db < 192)
      {
      Bios_PutString("- ");
      Bios_PutChar_P((192-vol_db) / 2);
      }; 
Bios_PutString(" dB\n\r");
}

